"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _getScrollInfo = require("get-scroll-info");

var _easeInOutCubic = _interopRequireDefault(require("easing-lib/easeInOutCubic"));

var isRunning = false;

var _call = function _call(func, scrollNode) {
  return function () {
    if ('function' !== typeof func) {
      return;
    }

    func(scrollNode);
  };
};
/**
 *  !!Important!! any logic change need take care isRunning
 */


var smoothScrollTo = function smoothScrollTo(to, duration, el, callback) {
  var scrollNode = (0, _getScrollInfo.getScrollNode)(el);

  var cb = _call(callback, scrollNode);

  if (isRunning) {
    isRunning = false;
    setTimeout(function () {
      scrollNode.scrollTop = to;
      cb();
    });
    return false;
  }

  if (!duration) {
    duration = 900;
  }

  var from = scrollNode.scrollTop;
  var go = to - from;

  if (!go) {
    isRunning = false;
    cb();
    return;
  }

  var beginTimeStamp;

  var scrollTo = function scrollTo(timeStamp) {
    beginTimeStamp = beginTimeStamp || timeStamp;
    var elapsedTime = timeStamp - beginTimeStamp;
    var progress = (0, _easeInOutCubic.default)(elapsedTime, from, go, duration);
    scrollNode.scrollTop = progress;

    if (elapsedTime < duration && go && isRunning) {
      requestAnimationFrame(scrollTo);
    } else {
      isRunning = false;
      cb();
    }
  };

  isRunning = true;
  requestAnimationFrame(scrollTo);
};

var _default = smoothScrollTo;
exports.default = _default;
module.exports = exports.default;